unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PaxCompiler, PaxProgram, PaxJavaScriptLanguage;

type
  TForm1 = class(TForm)
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    Button1: TButton;
    Button2: TButton;
    PaxJavaScriptLanguage1: TPaxJavaScriptLanguage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  t: Integer;
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxJavaScriptLanguage1);

  PaxCompiler1.AddModule('1', PaxJavaScriptLanguage1.LanguageName);

  PaxCompiler1.AddCode('1', 'function P()');
  PaxCompiler1.AddCode('1', '{');
  PaxCompiler1.AddCode('1', '  var d1, d2, i;');
  PaxCompiler1.AddCode('1', '  d1 = 5.4;');
  PaxCompiler1.AddCode('1', '  d2 = 9009960.3;');
  PaxCompiler1.AddCode('1', '  i = 0;');
  PaxCompiler1.AddCode('1', '  while (d1 < d2)');
  PaxCompiler1.AddCode('1', '  {');
  PaxCompiler1.AddCode('1', '    i++;');
  PaxCompiler1.AddCode('1', '    d1 += 0.5;');
  PaxCompiler1.AddCode('1', '  }');
  PaxCompiler1.AddCode('1', '}');
  PaxCompiler1.AddCode('1', 'P();');
  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    t := GetTickCount;
    PaxProgram1.Run;
    PaxProgram1.GetProgPtr.RootGC.Collect();
    ShowMessage(IntToStr(GetTickCount - t));
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure P();
var
  d1, d2: Double;
  I: Integer;
begin
  d1 := 5.4;
  d2 := 9009960.3;
  I := 0;
  while d1 < d2 do
  begin
    Inc(I);
    d1 := d1 + 0.5;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  t: Integer;
begin
  t := GetTickCount;
  P;
  ShowMessage(IntToStr(GetTickCount - t));
end;

end.
